## python2.7 2.7.3~rc2-2.1-maemo5

=== debian/changelog ===
python2.7 (2.7.3~rc2-2.1-maemo5) unstable; urgency=low

  * Fix ctypes (http://whocares.de/finally-a-fix-for-python-2-7-aborts-on-import-of-ctypes/)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu, 06 Jun 2013 09:10:26 +0200

python2.7 (2.7.3~rc2-2.1-maemo4) unstable; urgency=low

  * Run autoconf locally (builder's autoconf is pointing too old version)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu, 20 Sep 2012 15:27:26 +0200

python2.7 (2.7.3~rc2-2.1-maemo1) unstable; urgency=low

  * For Fremantle, optified

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Fri,  7 Sep 2012 16:00:26 +0200

python2.7 (2.7.3~rc2-2.1) unstable; urgency=low

  * Non-maintainer upload (with maintainer's permission).
  * Disable testsuite on GNU/kFreeBSD.  (Closes: #669281)

 -- Robert Millan <rmh@debian.org>  Sun, 22 Apr 2012 22:04:26 +0200

python2.7 (2.7.3~rc2-2) unstable; urgency=low

  * Use xdg-open/gvfs-open in Lib/webbrowser.py (Michael Vogt). 
    LP: #971311.
  * Add a paragraph about python-foo-dbg packages to README.debug.
    LP: #872050.
  * Disable some tests (no feedback from porters):
    - test_socket on hurd-i386.
    - test_io on amd64.
    - test_signal on kfreebsd-*. Closes: #654783.
    - test_threading on sparc.
  * Tighten build dependency on libexpat-dev. Closes: #665346.
  * Build-depend on db-5.1, don't care about testsuite regressions on
    some esoteric ports.  If packages rely on threaded applications or
    transactions, please use the python-bsddb3 package.
    Closes: #621374.
  * Don't ship the python2 and python2-config symlinks, move these
    to the python-minimal and python-dev packages. Closes: #663874.
  * Remove PVER-doc.doc-base.PVER-doc.in. Closes: #656763.
  * Update symbols files.
  * Avoid runtime path for the sqlite extension.
  * CVE-2011-4944, distutils creates ~/.pypirc insecurely. Closes: #650555.
  * Fix issue #14505, file descriptor leak when deallocating file objects
    created with PyFile_FromString(). Closes: #664529.

 -- Matthias Klose <doko@debian.org>  Thu, 05 Apr 2012 15:47:03 +0200

python2.7 (2.7.3~rc2-1) unstable; urgency=low

  * Python 2.7.3 release candidate 2.
  * Build-depend on expat >= 2.1~.

 -- Matthias Klose <doko@debian.org>  Wed, 21 Mar 2012 05:21:47 +0100

python2.7 (2.7.3~rc1-1) unstable; urgency=low

  * Python 2.7.3 release candidate 1.
  * Update to 20120309, taken from the 2.7 branch.
  * Fix dangling libpython.a symlink. Closes: #660231.

 -- Matthias Klose <doko@debian.org>  Fri, 09 Mar 2012 19:28:43 +0100

python2.7 (2.7.2-13) unstable; urgency=low

  * Update to 20120120, taken from the 2.7 branch.
  * Remove patch integrated upstream (issue9054.diff).
  * Backport Issue #9189 to distutils/sysconfig.py as well.
    Closes: #656118.
  * Disable test_io on kfreebsd again. Closes: #654783.
  * Disable test_bsddb3 tests on kfreebsd again.

 -- Matthias Klose <doko@debian.org>  Fri, 20 Jan 2012 16:33:47 +0100

python2.7 (2.7.2-12) unstable; urgency=low

  * Run the tests with a script command which doesn't exit immediatly
    when stdin is /dev/null (Colin Watson).

 -- Matthias Klose <doko@debian.org>  Fri, 13 Jan 2012 11:04:31 +0100

python2.7 (2.7.2-11) unstable; urgency=low

  * Don't run the test_site tests when $HOME doesn't exist.

 -- Matthias Klose <doko@debian.org>  Wed, 11 Jan 2012 09:19:00 +0100

python2.7 (2.7.2-10) unstable; urgency=low

  * Update to 20120110, taken from the 2.7 branch.
  * Overwrite some lintian warnings:
    - The -dbg interpreters are not unusual.
    - The -gdb.py files don't need a python dependency.
    - lintian can't handle a whatis entry starting with one word on the line.
  * Fix test failures related to distutils debian installation layout.
  * Add build-arch/build-indep targets.
  * Regenerate Setup and Makefiles after correcting Setup.local.
  * profiled-build.diff: Pass PY_CFLAGS instead of CFLAGS for the profiled
    build.
  * Pass dpkg-buildflags to the build process, and build third party
    extensions with these flags.
  * Add support to build using -flto (and -g1) on some architectures.
  * Disable pgo builds for some architectures (for now, keep just
    amd64 armel armhf i386 powerpc ppc64).
  * Build-depend on libgdbm-dev to build and run the gdbm tests.
  * Build-depend on xvfb to run the tkinter tests.
  * python2.7: Provide python2.7-argparse and python-argparse.
  * Don't run test_threading on mips/mipsel.
  * Run the test_gdb test for the debug build only.
  * Add build conflict to python-cxx-dev (pydoc test failures).
  * Disable test_ssl certificate check, certificate expired on python.org.

 -- Matthias Klose <doko@debian.org>  Tue, 10 Jan 2012 16:44:56 +0100

python2.7 (2.7.2-9) unstable; urgency=low

  * Update to 20111217, taken from the 2.7 branch.

 -- Matthias Klose <doko@debian.org>  Sat, 17 Dec 2011 17:36:27 +0100

python2.7 (2.7.2-8) unstable; urgency=low

  * Update to 20111130, taken from the 2.7 branch.
  * New patch, ctypes-arm, allow for ",hard-float" after libc6 in ldconfig -p
    output (Loic Minier). LP: #898172.
  * debian/rules: Define DPKG_VARS (Alban Browaeys). Closes: #647419).
  * Add python-config man page (Johann Felix Soden). Closes: #650181).

 -- Matthias Klose <doko@debian.org>  Wed, 30 Nov 2011 19:16:23 +0100

python2.7 (2.7.2-7) unstable; urgency=low

  * Adjust patches for removed Lib/plat-linux3.
  * Add build conflict to libncurses5-dev, let configure search for
    ncurses headers in /usr/include/ncursesw too.

 -- Matthias Klose <doko@debian.org>  Wed, 05 Oct 2011 11:30:16 +0200

python2.7 (2.7.2-6) unstable; urgency=low

  * Update to 20111004, taken from the 2.7 branch.
  * Use the ncursesw include directory when linking with ncursesw.
  * Rebuild with libreadline not linked with libncurses*. Closes: #643816.
  * Fix typos in the multiprocessing module. Closes: #643856.

 -- Matthias Klose <doko@debian.org>  Tue, 04 Oct 2011 16:09:29 +0200

python2.7 (2.7.2-5) unstable; urgency=low



=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_BITS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_BITS)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)

changelog_values := $(shell dpkg-parsechangelog \
			| awk '/^(Version|Source):/ {print $$2}')
PKGSOURCE  := $(word 1, $(changelog_values))
PKGVERSION := $(word 2, $(changelog_values))

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd ] && echo yes)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386))
  WITHOUT_BENCH := disabled on $(DEB_HOST_ARCH)
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(findstring $(DEB_HOST_ARCH), hppa mips mipsel s390))
#    WITHOUT_CHECK := yes
  endif
endif
ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-amd64 kfreebsd-i386))
  WITHOUT_CHECK := yes
endif

#Force testings off
WITHOUT_BENCH := yes
WITHOUT_CHECK := yes

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
#distribution := Ubuntu

VER=2.7
NVER=2.8
PVER=python2.7
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 == "extension" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_gdbm := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /$(PREFIX)/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
  ifeq ($(distribution),Ubuntu)
    PY_MINPRIO = required
  else
    PY_MINPRIO = $(PY_PRIO)
  endif
else
  PY_PRIO = optional
  PY_MINPRIO = $(PY_PRIO)
endif
with_fpectl = yes

CC = gcc

DPKG_CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-O0,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
# issues with ia64 and m68k with -O3
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64))
    with_pgo := yes
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386))
  with_lto := yes
endif
#Force:
with_lto := no

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    EXTRA_OPT_CFLAGS += -g1 -flto -fuse-linker-plugin
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  $(PREFIX)/share/lib/python$(VER)
scriptdir	=  $(PREFIX)/share/python$(VER)
scriptdir	=  $(PREFIX)/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_gdbm	:= $(PVER)-gdbm
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_gdbm	:= debian/$(p_gdbm)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
d_idle	:= debian/$(p_idle)
d_doc	:= debian/$(p_doc)
d_dbg	:= debian/$(p_dbg)

build-arch: stamps/stamp-build
build-indep: stamps/stamp-build-doc
build: build-arch
stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
    stamps/stamp-build-shared stamps/stamp-build-debug \
    stamps/stamp-build-shared-debug \
    stamps/stamp-check stamps/stamp-pystone stamps/stamp-pybench
	touch $@

PROFILE_EXCLUDES = test_compiler test_distutils test_platform test_subprocess \
	test_multiprocessing test_cprofile \
	test_thread test_threaded_import test_threadedtempfile \
	test_socketserver \
	test_threading test_threading_local test_threadsignals \
	test_dbm_dumb test_dbm_ndbm test_pydoc test_sundry test_gdb \

ifneq (,$(filter $(DEB_HOST_ARCH), arm armel))
  PROFILE_EXCLUDES += test_float
endif
ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-amd64 kfreebsd-i386))
  PROFILE_EXCLUDES += test_io
endif
PROFILE_EXCLUDES += test_zipfile
PROFILE_EXCLUDES += test_xmlrpc
PROFILE_EXCLUDES += test_bsddb3

PROFILE_TASK = ../Lib/test/regrtest.py \
	-x $(sort $(TEST_EXCLUDES) $(PROFILE_EXCLUDES))

stamps/stamp-build-static: stamps/stamp-configure-static
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_static) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)" \
		PROFILE_TASK='$(PROFILE_TASK)' $(make_build_target)
	touch stamps/stamp-build-static

stamps/stamp-build-shared: stamps/stamp-configure-shared
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_shared) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)"
#	: # build the shared library
#	$(MAKE) $(NJOBS) -C $(buildd_shared) \
#		libpython$(VER).so
	: # build a static library with PIC objects
	$(MAKE) $(NJOBS) -C $(buildd_shared) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)" \
		LIBRARY=libpython$(VER)-pic.a libpython$(VER)-pic.a
	touch stamps/stamp-build-shared

stamps/stamp-build-debug: stamps/stamp-configure-debug
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_debug)
		EXTRA_CFLAGS="$(DEBUG_CFLAGS)"
	touch stamps/stamp-build-debug

stamps/stamp-build-shared-debug: stamps/stamp-configure-shared-debug
	dh_testdir
	: # build the shared debug library
	$(MAKE) $(NJOBS) -C $(buildd_shdebug) \
		libpython$(VER)_d.so
	touch stamps/stamp-build-shared-debug

PREFIX=opt/python27
common_configure_args = \
		--prefix=/$(PREFIX) \
		--enable-ipv6 \
		--enable-unicode=ucs4 \
		--with-dbmliborder=bdb:gdbm \
		--with-system-expat

ifeq ($(DEB_HOST_ARCH), avr32)
  common_configure_args += --without-ffi
else
  common_configure_args += --with-system-ffi
endif

ifeq ($(with_fpectl),yes)
  common_configure_args += \
		--with-fpectl
endif

stamps/stamp-configure-shared: stamps/stamp-patch
	rm -rf $(buildd_shared)
	mkdir -p $(buildd_shared)
	cd $(buildd_shared) && \
	  CC="$(CC)" CFLAGS="$(OPT_CFLAGS)" LDFLAGS="$(DPKG_LDFLAGS)" \
	    ../configure \
		--enable-shared \
		$(common_configure_args)

	$(call __post_configure,$(buildd_shared))

	touch stamps/stamp-configure-shared

stamps/stamp-configure-static: stamps/stamp-patch
	rm -rf $(buildd_static)
	mkdir -p $(buildd_static)
	cd $(buildd_static) && \
	  CC="$(CC)" CFLAGS="$(OPT_CFLAGS)" LDFLAGS="$(DPKG_LDFLAGS)" \
	    ../configure \

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/2\.7(\.\d)?/Python-(2\.7[.\dabcr]*)\.tgz

## python2.7 2.7.6

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python
SVNROOT      = http://svn.python.org/projects
SPHINXOPTS   =
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/sphinxext/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help checkout update build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  update     to update build tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

# Note: if you update versions here, do the same in make.bat and README.txt
checkout:
	@if [ ! -d tools/sphinx ]; then \
	  echo "Checking out Sphinx..."; \
	  svn checkout $(SVNROOT)/external/Sphinx-1.0.7/sphinx tools/sphinx; \
	fi
	@if [ ! -d tools/docutils ]; then \
	  echo "Checking out Docutils..."; \
	  svn checkout $(SVNROOT)/external/docutils-0.6/docutils tools/docutils; \
	fi
	@if [ ! -d tools/jinja2 ]; then \
	  echo "Checking out Jinja..."; \
	  svn checkout $(SVNROOT)/external/Jinja-2.3.1/jinja2 tools/jinja2; \
	fi
	@if [ ! -d tools/pygments ]; then \
	  echo "Checking out Pygments..."; \
	  svn checkout $(SVNROOT)/external/Pygments-1.3.1/pygments tools/pygments; \
	fi

update: clean checkout

build: checkout
	mkdir -p build/$(BUILDER) build/doctrees
	$(PYTHON) tools/sphinx-build.py $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck: build
	@echo "Link check complete; look for any errors in the above output" \
	      "or in build/$(BUILDER)/output.txt"

suspicious: BUILDER = suspicious
suspicious: build
	@echo "Suspicious check complete; look for any errors in the above output" \
	      "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	      "positives, append that file to tools/sphinxext/susp-ignored.csv."

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest: build
	@echo "Testing of doctests in the sources finished, look at the" \
	      "results in build/doctest/output.txt"

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now copy build/pydoc-topics/topics.py" \
	      "to Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/*
	-rm -rf tools/sphinx
	-rm -rf tools/pygments
	-rm -rf tools/jinja2
	-rm -rf tools/docutils

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

check:
	$(PYTHON) tools/rstlint.py -i tools

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make update
	make dist SPHINXOPTS='-A daily=1 -A versionswitcher=1'

# for quick rebuilds (HTML only)
autobuild-html:
	make html SPHINXOPTS='-A daily=1 -A versionswitcher=1'

# for stable releases: only build if not in pre-release stage (alpha, beta, rc)
autobuild-stable:
	@case $(DISTVERSION) in *[abc]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

## python2.7 2.7.3~rc2-2.1-maemo6

=== debian/changelog ===
python2.7 (2.7.3~rc2-2.1-maemo6) unstable; urgency=low

  * Version bump (same version than before)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Fri, 16 Aug 2013 19:02:26 +0200

=== debian/control ===
Source: python2.7
Section: python
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com>
Build-Depends: debhelper (>= 5), quilt, autoconf, lsb-release, sharutils,
  libreadline5-dev, libncursesw5-dev (>= 5.3),
  tk8.5-dev, blt-dev (>= 2.4z), libssl-dev,
  zlib1g-dev, libbz2-dev,
  libexpat1-dev,
  libbluetooth3-dev [linux-any],
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5),
  mime-support, netbase, bzip2,
  libdb4.2-dev, libgdbm-dev, gdb, python, help2man,
  xvfb, xauth
Build-Conflicts: tcl8.4-dev, tk8.4-dev, python2.7-xml, python-xml, autoconf2.13, python-cxx-dev
Standards-Version: 3.9.3
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg2.7-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg2.7-debian

Package: python2.7
Architecture: any
Priority: optional
Depends: python2.7-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python2.7-doc, binutils
Provides: python2.7-cjkcodecs, python2.7-ctypes, python2.7-elementtree, python2.7-celementtree, python2.7-wsgiref, python2.7-profiler, python2.7-argparse, python-argparse
Conflicts: python-profiler (<= 2.7.1-2)
Replaces: python-profiler (<= 2.7.1-2)
Description: Interactive high-level object-oriented language (version 2.7)
 Version 2.7 of the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python2.7-minimal
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: python2.7
Suggests: binfmt-support
Replaces: python2.7 (<< 2.7.1~rc1-2~)
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 2.7)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python2.7-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython2.7
Architecture: any
Section: libs
Priority: optional
Depends: python2.7 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: python2.7 (<< 2.6)
Description: Shared Python runtime library (version 2.7)
 Version 2.7 of the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python2.7-examples
Architecture: all
Depends: python2.7 (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v2.7)
 Examples, Demos and Tools for Python (v2.7). These are files included in
 the upstream Python distribution (v2.7).

Package: python2.7-dev
Architecture: any
Depends: python2.7 (= ${binary:Version}), libpython2.7 (= ${binary:Version}), libexpat1-dev, libssl-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Replaces: python2.7 (<< 2.7-3)
Description: Header files and a static library for Python (v2.7)
 Header files, a static library and development tools for building
 Python (v2.7) modules, extending the Python interpreter or embedding
 Python (v2.7) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: idle-python2.7
Architecture: all
Depends: python2.7, python-tk (>= 2.6~a3), python2.7-tk, ${misc:Depends}
Enhances: python2.7
Replaces: python2.7 (<< 2.6.1-2)
Description: IDE for Python (v2.7) using Tkinter
 IDLE is an Integrated Development Environment for Python (v2.7).
 IDLE is written using Tkinter and therefore quite platform-independent.


Package: python2.7-dbg
Section: debug
Architecture: any
Priority: extra
Depends: python2.7 (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: python-gdbm-dbg, python-tk-dbg
Description: Debug Build of the Python Interpreter (version 2.7)
 Python interpreter configured with --pydebug. Dynamically loaded modules are
 searched in /usr/lib/python2.7/lib-dynload/debug first.

## python2.7 2.7.3~rc2-2.1-maemo8

=== debian/changelog ===
python2.7 (2.7.3~rc2-2.1-maemo8) unstable; urgency=low

  * Dropped one more profiled build

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Tue, 19 Nov 2013 18:43:26 +0200

python2.7 (2.7.3~rc2-2.1-maemo7) unstable; urgency=low

  * Version bump (same version than before): repository deleted previous version

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu, 14 Nov 2013 14:19:26 +0200

## python2.7 2.7.3~rc2-2.1-maemo9

=== debian/changelog ===
python2.7 (2.7.3~rc2-2.1-maemo9) unstable; urgency=low

  * For Fremantle, optified
  * Fix ctypes (http://whocares.de/finally-a-fix-for-python-2-7-aborts-on-import-of-ctypes/)
  * Run autoconf locally (builder's autoconf is pointing too old version)
  * Dropped profiled build

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sun, 24 Nov 2013 22:06:26 +0200

=== debian/rules ===
--- 
+++ 
@@ -144,7 +144,8 @@
     EXTRA_OPT_CFLAGS += -g1 -flto -fuse-linker-plugin
 endif
 
-make_build_target = $(if $(with_pgo),profile-opt)
+make_build_target = 
+#make_build_target = $(if $(with_pgo))
 
 buildd_static	:= $(CURDIR)/build-static
 buildd_shared	:= $(CURDIR)/build-shared

## python2.7 2.7.12

=== Doc/Makefile ===
--- 
+++ 
@@ -5,27 +5,27 @@
 
 # You can set these variables from the command line.
 PYTHON       = python
-SVNROOT      = http://svn.python.org/projects
-SPHINXOPTS   =
+SPHINXBUILD  = sphinx-build
 PAPER        =
 SOURCES      =
-DISTVERSION  = $(shell $(PYTHON) tools/sphinxext/patchlevel.py)
+DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
 
 ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
                 $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)
 
-.PHONY: help checkout update build html htmlhelp latex text changes linkcheck \
+.PHONY: help build html htmlhelp latex text changes linkcheck \
 	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
 	autobuild-dev autobuild-stable
 
 help:
 	@echo "Please use \`make <target>' where <target> is one of"
 	@echo "  clean      to remove build files"
-	@echo "  update     to update build tools"
 	@echo "  html       to make standalone HTML files"
+	@echo "  htmlview   to open the index page built by the html target in your browser"
 	@echo "  htmlhelp   to make HTML files and a HTML help project"
 	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
 	@echo "  text       to make plain text files"
+	@echo "  epub       to make EPUB files"
 	@echo "  changes    to make an overview over all changed/added/deprecated items"
 	@echo "  linkcheck  to check all external links for integrity"
 	@echo "  coverage   to check documentation coverage for library and C API"
@@ -36,30 +36,8 @@
 	@echo "  check      to run a check for frequent markup errors"
 	@echo "  serve      to serve the documentation on the localhost (8000)"
 
-# Note: if you update versions here, do the same in make.bat and README.txt
-checkout:
-	@if [ ! -d tools/sphinx ]; then \
-	  echo "Checking out Sphinx..."; \
-	  svn checkout $(SVNROOT)/external/Sphinx-1.0.7/sphinx tools/sphinx; \
-	fi
-	@if [ ! -d tools/docutils ]; then \
-	  echo "Checking out Docutils..."; \
-	  svn checkout $(SVNROOT)/external/docutils-0.6/docutils tools/docutils; \
-	fi
-	@if [ ! -d tools/jinja2 ]; then \
-	  echo "Checking out Jinja..."; \
-	  svn checkout $(SVNROOT)/external/Jinja-2.3.1/jinja2 tools/jinja2; \
-	fi
-	@if [ ! -d tools/pygments ]; then \
-	  echo "Checking out Pygments..."; \
-	  svn checkout $(SVNROOT)/external/Pygments-1.3.1/pygments tools/pygments; \
-	fi
-
-update: clean checkout
-
-build: checkout
-	mkdir -p build/$(BUILDER) build/doctrees
-	$(PYTHON) tools/sphinx-build.py $(ALLSPHINXOPTS)
+build:
+	$(SPHINXBUILD) $(ALLSPHINXOPTS)
 	@echo
 
 html: BUILDER = html
@@ -81,44 +59,50 @@
 text: build
 	@echo "Build finished; the text files are in build/text."
 
+epub: BUILDER = epub
+epub: build
+	@echo "Build finished; the epub files are in build/epub."
+
 changes: BUILDER = changes
 changes: build
 	@echo "The overview file is in build/changes."
 
 linkcheck: BUILDER = linkcheck
-linkcheck: build
-	@echo "Link check complete; look for any errors in the above output" \
-	      "or in build/$(BUILDER)/output.txt"
+linkcheck:
+	@$(MAKE) build BUILDER=$(BUILDER) || { \
+	echo "Link check complete; look for any errors in the above output" \
+	     "or in build/$(BUILDER)/output.txt"; \
+	false; }
 
 suspicious: BUILDER = suspicious
-suspicious: build
-	@echo "Suspicious check complete; look for any errors in the above output" \
-	      "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
-	      "positives, append that file to tools/sphinxext/susp-ignored.csv."
+suspicious:
+	@$(MAKE) build BUILDER=$(BUILDER) || { \
+	echo "Suspicious check complete; look for any errors in the above output" \
+	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
+	     "positives, append that file to tools/susp-ignored.csv."; \
+	false; }
 
 coverage: BUILDER = coverage
 coverage: build
 	@echo "Coverage finished; see c.txt and python.txt in build/coverage"
 
 doctest: BUILDER = doctest
-doctest: build
-	@echo "Testing of doctests in the sources finished, look at the" \
-	      "results in build/doctest/output.txt"
+doctest:
+	@$(MAKE) build BUILDER=$(BUILDER) || { \
+	echo "Testing of doctests in the sources finished, look at the" \
+	     "results in build/doctest/output.txt"; \
+	false; }
 
 pydoc-topics: BUILDER = pydoc-topics
 pydoc-topics: build
 	@echo "Building finished; now copy build/pydoc-topics/topics.py" \
-	      "to Lib/pydoc_data/topics.py"
+	      "to ../Lib/pydoc_data/topics.py"
 
 htmlview: html
 	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"
 
 clean:
 	-rm -rf build/*
-	-rm -rf tools/sphinx
-	-rm -rf tools/pygments
-	-rm -rf tools/jinja2
-	-rm -rf tools/docutils
 
 dist:
 	rm -rf dist
@@ -158,6 +142,11 @@
 	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
 	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2
 
+	# copy the epub build
+	rm -rf build/epub
+	make epub
+	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub
+
 check:
 	$(PYTHON) tools/rstlint.py -i tools
 
@@ -168,16 +157,17 @@
 
 # for development releases: always build
 autobuild-dev:
-	make update
 	make dist SPHINXOPTS='-A daily=1 -A versionswitcher=1'
+	-make suspicious
 
 # for quick rebuilds (HTML only)
 autobuild-html:
 	make html SPHINXOPTS='-A daily=1 -A versionswitcher=1'
 
-# for stable releases: only build if not in pre-release stage (alpha, beta, rc)
+# for stable releases: only build if not in pre-release stage (alpha, beta)
+# release candidate downloads are okay, since the stable tree can be in that stage
 autobuild-stable:
-	@case $(DISTVERSION) in *[abc]*) \
+	@case $(DISTVERSION) in *[ab]*) \
 		echo "Not building; $(DISTVERSION) is not a release version."; \
 		exit 1;; \
 	esac

## python2.7 2.7.15~rc1

=== Doc/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 SOURCES      =
 DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
 
-ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
+ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_elements.papersize=$(PAPER) \
                 $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)
 
 .PHONY: help build html htmlhelp latex text changes linkcheck \
@@ -157,12 +157,12 @@
 
 # for development releases: always build
 autobuild-dev:
-	make dist SPHINXOPTS='-A daily=1 -A versionswitcher=1'
+	make dist SPHINXOPTS='$(SPHINXOPTS) -A daily=1 -A switchers=1'
 	-make suspicious
 
 # for quick rebuilds (HTML only)
-autobuild-html:
-	make html SPHINXOPTS='-A daily=1 -A versionswitcher=1'
+autobuild-dev-html:
+	make html SPHINXOPTS='$(SPHINXOPTS) -A daily=1 -A switchers=1'
 
 # for stable releases: only build if not in pre-release stage (alpha, beta)
 # release candidate downloads are okay, since the stable tree can be in that stage
@@ -173,3 +173,9 @@
 	esac
 	@make autobuild-dev
 
+autobuild-stable-html:
+	@case $(DISTVERSION) in *[ab]*) \
+		echo "Not building; $(DISTVERSION) is not a release version."; \
+		exit 1;; \
+	esac
+	@make autobuild-dev-html

## python2.7 2.7.16.2

=== debian/changelog ===
python2.7 (2.7.16.2-1+eagle) unstable; urgency=medium

  * update

 -- Matthias Klose <doko@debian.org>  Fri, 26 Feb 2021 14:12:30 +0800

python2.7 (2.7.16.1-1+dde) unstable; urgency=medium

  * update changelog.
  * 

 -- liuxin <liuxin@uniontech.com>  Wed, 29 Jul 2020 20:39:06 +0800

python2.7 (2.7.16-2+deb10u1) buster; urgency=medium

  * CVE-2018-20852
  * CVE-2019-10160
  * CVE-2019-16056 (Closes: #940901)
  * CVE-2019-16935
  * CVE-2019-9740
  * CVE-2019-9947

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 11 Oct 2019 00:02:15 +0200

python2.7 (2.7.16-2) unstable; urgency=high

  [ Matthias Klose ]
  * CVE-2019-9636. Fix issue #36216: Add check for characters in netloc that
    normalize to separators. Closes: #924073.
  * CVE-2019-9948. Fix issue #35907: Stop urllib exposing the local_file schema
    (file://).

  [ Dimitri John Ledkov ]
  * Bump Build-Depedency and Dependency of libssl-dev and libss1.1 to
    1.1.1 or higher. As TLS1.3 constants leak into ssl module, thus one
    shouldn't mix and match python2.7 & libssl1.1. LP: #1808476

 -- Matthias Klose <doko@debian.org>  Sat, 06 Apr 2019 03:42:57 +0200

python2.7 (2.7.16-1) unstable; urgency=medium

  * Python 2.7.16 release.
    - Now has a version without a trailing '+'. Closes: #914072.

 -- Matthias Klose <doko@debian.org>  Mon, 04 Mar 2019 16:29:09 +0100

python2.7 (2.7.16~rc1-1) unstable; urgency=medium

  * Python 2.7.16 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Mon, 18 Feb 2019 12:05:09 +0100

python2.7 (2.7.15-9) unstable; urgency=medium

  * Update to 20190216 from the 2.7 branch.
    - Backport of TLS 1.3 related fixes from 3.7.
  * Drop the local TLS 1.3 backports.

 -- Matthias Klose <doko@debian.org>  Sat, 16 Feb 2019 11:39:20 +0100

python2.7 (2.7.15-8) unstable; urgency=medium

  * Fix typo in autopkg test.

 -- Matthias Klose <doko@debian.org>  Sun, 03 Feb 2019 14:13:16 +0100

python2.7 (2.7.15-7) unstable; urgency=medium

  * Expect the test_site test failing as in 3.7.

 -- Matthias Klose <doko@debian.org>  Sun, 03 Feb 2019 12:51:14 +0100

python2.7 (2.7.15-6) unstable; urgency=medium

  * Update to 20190201 from the 2.7 branch.
    - CVE-2013-1752: Limit imaplib.IMAP4_SSL.readline().
    - CVE-2018-14647: _elementtree.c doesn't call XML_SetHashSalt().
      Closes: #921039.
    - CVE-2019-5010: DsO vulnerability exists in the X509 certificate parser.
      Closes: #921040.
  * Bump standards version.
  * Update symbols file.

 -- Matthias Klose <doko@debian.org>  Fri, 01 Feb 2019 08:18:31 +0100

python2.7 (2.7.15-5) unstable; urgency=medium

  * Update to 20181127 from the 2.7 branch.
    - Fix issue #20744, running an external 'zip' in shutil.make_archive().
      CVE-2018-1000802. Closes: #909673.
  * Cherrypick in-progress backports to 2.7 branch from 3.6 branch to fix
    test_ssl assertions with openssl 1.1.1. Resolves autopkgtest failure
    of the 2.7 with openssl 1.1.1 (Dimitri John Ledkov).
  * Don't hard code location of netinet/in.h. Closes: #912422.
  * Update VCS attributes.

 -- Matthias Klose <doko@debian.org>  Wed, 28 Nov 2018 17:27:22 +0100

python2.7 (2.7.15-4) unstable; urgency=medium

  * Update to 20180831 from the 2.7 branch.
    - Fixes the build with OpenSSL 1.1.1. Closes: #900157.
  * Don't run the test_ftplib and test_ssl autopkg tests, not yet ready
    for OpenSSL 1.1.1. Closes: #907033.

 -- Matthias Klose <doko@debian.org>  Fri, 31 Aug 2018 13:56:52 +0200

python2.7 (2.7.15-3) unstable; urgency=medium

  * Bump standards version.
  * Pass the list of the pyFPE breaks as a parameter into dpkg-gencontrol
    instead of hard-coding them in the control file.

 -- Matthias Klose <doko@debian.org>  Sat, 28 Jul 2018 13:29:29 +0200

python2.7 (2.7.15-1) unstable; urgency=medium

  * Python 2.7.15 release.

 -- Matthias Klose <doko@debian.org>  Tue, 01 May 2018 07:55:50 +0200

python2.7 (2.7.15~rc1-1) unstable; urgency=medium

  * Python 2.7.15 release candidate 1.

 -- Matthias Klose <doko@debian.org>  Sun, 15 Apr 2018 23:51:34 +0200

python2.7 (2.7.14-8) unstable; urgency=medium

  * Update to 20180402 from the 2.7 branch.

 -- Matthias Klose <doko@debian.org>  Mon, 02 Apr 2018 06:16:25 +0200

python2.7 (2.7.14-7) unstable; urgency=medium

  * Update to 20180313 from the 2.7 branch.
    - Fix issue #32185: The SSL module no longer sends IP addresses in SNI TLS
      extension on platforms with OpenSSL 1.0.2+ or inet_pton. See #892814.
  * Add support for riscv64 (Aurelien Jarno). Closes: #892329.

 -- Matthias Klose <doko@debian.org>  Tue, 13 Mar 2018 16:23:44 +0100

python2.7 (2.7.14-6) unstable; urgency=medium

  * Don't run lib2to3 tests which rely on the pickled grammar files.

 -- Matthias Klose <doko@debian.org>  Tue, 06 Feb 2018 20:12:18 +0100

python2.7 (2.7.14-5) unstable; urgency=medium

  * Update to 20180204 from the 2.7 branch.
    - Fix issue #31530. Closes: #889280.
  * python2.7-minimal: Pre-Depend on zlib1g. Closes: #887629.

 -- Matthias Klose <doko@debian.org>  Sun, 04 Feb 2018 09:35:17 +0100

python2.7 (2.7.14-4) unstable; urgency=medium

  * Fix applying the m-i-p-s-r6 patch.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Dec 2017 16:17:02 +0100

python2.7 (2.7.14-3) unstable; urgency=medium

  * Update to 20171205 from the 2.7 branch.
  * Build with -fstack-protector instead of -fstack-protector-strong.
    Performance improvements of around 1-2%.
  * Add support for mipsr6 triplets (YunQiang Su). Closes: #881945.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Dec 2017 10:01:24 +0100

python2.7 (2.7.14-2) unstable; urgency=medium

  * Really rename the md5_* functions.

 -- Matthias Klose <doko@debian.org>  Sun, 17 Sep 2017 20:50:44 +0200

python2.7 (2.7.14-1) unstable; urgency=medium

  * Python 2.7.14 release.

 -- Matthias Klose <doko@debian.org>  Sun, 17 Sep 2017 14:27:46 +0200

python2.7 (2.7.14~rc1-3) unstable; urgency=medium

  * Add package breaks for extensions referencing symbols for the removed


=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS CPPFLAGS LDFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_BITS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_BITS)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

changelog_values := $(shell dpkg-parsechangelog \
			| awk '/^(Version|Source):/ {print $$2}')
PKGSOURCE  := $(word 1, $(changelog_values))
PKGVERSION := $(word 2, $(changelog_values))

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386))
  WITHOUT_BENCH := disabled on $(DEB_HOST_ARCH)
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(findstring $(DEB_HOST_ARCH), hppa mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el s390))
    WITHOUT_CHECK := yes
  endif
endif
ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 kfreebsd-amd64 kfreebsd-i386))
  WITHOUT_CHECK := yes
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)

VER=2.7
NVER=2.8
PVER=python2.7
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = yes
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_gdbm := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  ifneq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid precise trusty xenial yakkety))
    PY_PRIO = standard
  else
    PY_PRIO = optional
  endif
  #PYSTDDEP = , python (>= $(VER))
  PY_MINPRIO = $(PY_PRIO)
else
  PY_PRIO = optional
  PY_MINPRIO = $(PY_PRIO)
endif
ifneq (,$(filter $(distrelease),stretch lenny squeeze wheezy precise xenial yakkety zesty))
  with_fpectl = yes
endif

ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),jessie experimental))
  bd_gcc =
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty utopic vivid wily xenial))
  pf_bluetooth = $(EMPTY) <!profile.nobluetooth>
endif

CC = $(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CFLAGS  := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(filter-out -D_FORTIFY_SOURCE=%,$(patsubst -O%,-O0,$(DPKG_CFLAGS)))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
# issues with ia64 and m68k with -O3
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
  ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32))
    with_pgo := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  with_pgo :=
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 powerpc ppc64 ppc64el s390x x32))
  with_lto := yes
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s/.* //p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

ifneq ($(with_fpectl),yes)
  ifeq ($(derivative),Ubuntu)
    arch_substvars =  '-Vpyfpe:Breaks=$(shell tr '\n' ' ' < debian/pyfpe-breaks.$(derivative))'
  else ifeq ($(derivative),Debian)
    arch_substvars =  '-Vpyfpe:Breaks=$(shell tr '\n' ' ' < debian/pyfpe-breaks.$(derivative))'
  endif
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_gdbm	:= $(PVER)-gdbm
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_gdbm	:= debian/$(p_gdbm)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
